// created: 8.6.01 modified: 1.8.01
// Stephan Dale
// MAVERIK (v6.0) avatar library header
/*
//#include <stdio.h>
#include <math.h>*/
#include "maverik.h"
//#include "mav_avatar.h" // for avatar structure definition
//#include <math.h>
//#include "maverik.h"
//#include "mav_avatar.h" // for avatar structure definition
//#include "../src/extras/avatar/mavlib_avatar.h" // for final variable declarations used to access avatar parts data
//#include "mav_tdm.h"
//include "../src/extras/TDM/mavlib_tdm.h" // for mavlib_TDM_calcPos function

// location of torso sensor
#define FRONT 0
#define BACK 1

/**************************************************************************************************/

/**********************************/
/* user-level function prototypes */
/**********************************/

void testHands(void *unused);

void showSetArmVectors(void *unused);
void showVectors(void *unused);
void showNetworkElbow(void *unused);
void showTrackedElbow(void *unused);
void showAxis(void *unused);

void createAvatar(MAV_SMS **sms);
void resetPosition(void);
int scaleAvatar(char *fileName);
void donkeyKong(void);

void avatarView(MAV_window *w);
void floatingFarView(MAV_window *w);
void floatingNearView(MAV_window *w);

void walk(MAV_viewParams *vp, float amount, float ls, float as);
void turn(MAV_viewParams *vp, float amount, float ls, float as);
void yawHead(MAV_viewParams *vp, float amount, float ls, float as);
void pitchHead(MAV_viewParams *vp, float amount, float ls, float as);

void initTrackers(int torsoSensor);
void setOffsets(void);
void trackHead(void *unused);
void trackUpperBody(void *unused);
void trackElbow(void *unused);

int loadNetwork(char *filename);
void predictElbows(void *unused);

void moveForwards(void *unused);
void moveBackwards(void *unused);
void turnRight(void *unused);
void turnLeft(void *unused);
void leftHandFurther(void *unused);
void leftHandCloser(void *unused);
void leftHandUp(void *unused);
void leftHandDown(void *unused);
void leftHandRight(void *unused);
void leftHandLeft(void *unused);
void rightHandFurther(void *unused);
void rightHandCloser(void *unused);
void rightHandUp(void *unused);
void rightHandDown(void *unused);
void rightHandRight(void *unused);
void rightHandLeft(void *unused);

void leftHandRollRight(void *unused);
void leftHandRollLeft(void *unused);
void leftHandPitchUp(void *unused);
void leftHandPitchDown(void *unused);
void leftHandYawRight(void *unused);
void leftHandYawLeft(void *unused);
void rightHandRollRight(void *unused);
void rightHandRollLeft(void *unused);
void rightHandPitchUp(void *unused);
void rightHandPitchDown(void *unused);
void rightHandYawRight(void *unused);
void rightHandYawLeft(void *unused);

void leftArmPitchUp(void *unused);
void leftArmPitchDown(void *unused);
void leftArmYawRight(void *unused);
void leftArmYawLeft(void *unused);
void rightArmPitchUp(void *unused);
void rightArmPitchDown(void *unused);
void rightArmYawRight(void *unused);
void rightArmYawLeft(void *unused);
void fixHeadLookingForward(void *unused);
void fixHeadLookingDown(void *unused);
void headLeft(void *unused);
void headRight(void *unused);
void headUp(void *unused);
void headDown(void *unused);
void torsoRollRight(void *unused);
void torsoRollLeft(void *unused);
void torsoPitchBack(void *unused);
void torsoPitchForward(void *unused);
void torsoYawRight(void *unused);
void torsoYawLeft(void *unused);

//void setArms(void *unused);

/**************************************************************************************************/
