// created by ajb 1998
// modified by Steph (sjd) 2001
// - changed output to stdout

#include <stdio.h>
#include <string.h>
#include "nettools.h"
#include "backprop.h"
//include "maverik.h"

extern float *alloc_1d_flt();
int data_count;
/*
  Function
  Input BPNN *net - the neural network
        filename  - File containing input/target data for net
  Return - Link list of the data read
*/

entry *load_netinput(BPNN *net,char *filename)

{
  FILE *infile;
  int i,num_input,num_target;
  entry *head=NULL,*node;

  if((infile = fopen(filename,"r"))==NULL)
    return(NULL);

  num_input= net->input_n;
  num_target=net->output_n;

  node=(entry*)malloc(sizeof(entry));
  data_count=0;

  while(!feof(infile))
    {
      if (head==NULL)
	{
	  head=node;
	}
      else
	{
	  node->next=(entry*)malloc(sizeof(entry));
	  node=node->next;
	}

      /* Allocate memory for the input vector and read them*/



      node->input_vector=alloc_1d_flt(num_input+1);



      for(i=1;i<=num_input;i++)
	fscanf(infile,"%f",&(node->input_vector[i]));


      /* Allocate memory for the target vector and read them*/


      node->target_vector=alloc_1d_flt(num_target+1);

      for(i=1;i<=num_target;i++)
	fscanf(infile,"%f",&(node->target_vector[i]));



      node->next=NULL;

      data_count++;

      /*printf(" vector %d = ", data_count);
      for(i=1;i<=num_input;i++)
	printf("%f ",node->input_vector[i]);
      for(i=1;i<=num_target;i++)
	printf("%f ",node->target_vector[i]);
      printf("\n");*/
    }
  fclose(infile);
  return(head);
}


/*
  Function
  Input BPNN *net - the neural network
        data   - single  data input array
  Return - Link list of the data read
*/

entry *load_single_netinput(BPNN *net,float *data)

{
  int i,num_input;
  entry *node;

  num_input= net->input_n;
  node=(entry*)malloc(sizeof(entry));
      
  /* Allocate memory for the input vector and read them*/
  node->input_vector=alloc_1d_flt(num_input+1);
  for(i=1;i<=num_input;i++)
    node->input_vector[i]=data[i];

  return(node);
}


void display_netindata(head,net)
entry *head;
BPNN *net;
{
  entry *node= head;
  int i,num_input,num_target;
  printf(" Display : Head ->%d",node);
  num_input= net->input_n;
  num_target=net->output_n;
  
  while(node!=NULL)
    {
      printf("\n*** Node ***\n");
      printf("Inputs\n");
      for(i=1;i<=num_input;i++)
	printf("%f ",node->input_vector[i]);
      printf("Targets\n ");
      for(i=1;i<=num_target;i++)
	printf("%f ",node->target_vector[i]);
      node=node->next;
    }
  
}


/*
  Function sets the input and target values for the neuralnet
  using the data read into the link list ;)
*/

void set_netintargetdata(node,net)
entry *node;
BPNN *net;
{
  int i,num_input,num_target;
  num_input= net->input_n;
  num_target= net->output_n;

  /* Setting Inputs */
  for(i=1;i<=num_input;i++)
    net->input_units[i]=node->input_vector[i];
  /* Setting Targets */
  for(i=1;i<=num_target;i++)
    net->target[i]=node->target_vector[i];

}


void set_netindata(node,net)
entry *node;
BPNN *net;
{
  int i,num_input;
  num_input= net->input_n;

  for(i=1;i<=num_input;i++)
    net->input_units[i]=node->input_vector[i];

}


/* 
   Function Modify the NN input file 
   Split the input data  into various range to 
   increase NN sensitivity ... 
   The input data is normalised so that the input values range from 0 to 1 
   and so are the target values ;-)
*/

void sensitizeinput(filename,method,chunk)
     char filename[10]; /* Name of input File */
     int chunk; /* Number of Chunks */
     int method; /* method for splitting 0=equal chunks
		    1=normalised distribution */
     
{
  FILE *finput,*foutput;
  char *infile,*outfile;
  float indata,outdata;
  float chunk_size;
  float i;
  infile = (char*)malloc((strlen(filename)+4)*sizeof(char));
  outfile = (char*)malloc((strlen(filename)+4)*sizeof(char));
  strcpy(infile,filename);
  strcat(infile,".nor");
  strcpy(outfile,filename);
  strcat(outfile,".mod");
  printf("%s %s",infile,outfile);
   
  if((finput=fopen(infile,"r"))==0)
    {
      printf("Error opening input file %s \n",infile);
      exit(1);
    }
  if((foutput=fopen(outfile,"w"))==0)
    {
      printf("Error opening output file %s \n",outfile);
      exit(1);
    }
  chunk_size = 1/(float)chunk;
  
  printf(" I am here %f",chunk_size);
  
  while(!feof(finput))
    {
      fscanf(finput,"%f",&indata);
      printf("\nData Read %f\n",indata);
      printf("Decomposed into \n");
      i=0;
      while(i<1)
	{
	  if(indata>=i && indata<(i+chunk_size))
	    outdata=(indata-i)/chunk_size;
	  else
	    if(indata >=i+chunk_size)
	      outdata=1;
	    else
	      outdata=0;
	  printf("Range %f to %f : %f \n",i,i+chunk_size,outdata);
	  fprintf(foutput,"%f\n",outdata);
	  i+=chunk_size;
	}
      
    }
  fclose(finput);
  fclose(foutput);
  
}






